#include <sys/types.h>
#include <sys/shm.h>
#include <strings.h>
#include <errno.h>
#include <stdio.h>

#ifdef DEBUG
#define dprintf printf
#else
#define dprintf if (0) printf
#endif


key_t ftok_check (char *name, int index)
{
  key_t temp;

  dprintf ("ftok (\'%s\',%d)...", name, index);
  temp = ftok (name, index);
  if (temp == (key_t) - 1)
    {
      dprintf ("error %d, %s\n", errno, strerror (errno));
      exit (1);
    }
  dprintf ("key value %0qx\n", temp);
  return temp;
}

int
main (void)
{
  key_t mykey;
  int shmid;
  char *testch = NULL;

  mykey = ftok_check ("shmat.o", 1);
  dprintf ("creating \'shmat.o:1\'... ");

  shmid = shmget (mykey, 65536, 0777 | IPC_CREAT);
  if (shmid != -1)
    {
      dprintf ("id %x\n", shmid);
      dprintf ("attaching... ");
      testch = (char *) shmat (shmid, NULL, 0);
      if (testch == (char *) -1)
	{
	  dprintf ("error %d, %s\n", errno, strerror (errno));
	  /* todo: delete the shm area */
	  return 1;
	}
      dprintf ("mapped to %x\n", testch);
      dprintf ("reading ... '%s'\n", testch);
#ifdef INTERACTIVE
      printf ("waiting for enter\n");
      getc (stdin);
#endif
      dprintf ("writing \'hello\' ...\n");
      snprintf (testch, 6, "hello");
      dprintf ("reading ...");
      dprintf ("'%s'\n", testch);
#ifdef INTERACTIVE
      printf ("waiting for enter\n");
      getc (stdin);
#endif
    }
  else
    {
      dprintf ("error %d, %s\n", errno, strerror (errno));
      return 1;
    }

  return 0;
}
