#include <sys/unistd.h>
#include <sys/types.h>
#include <sys/shm.h>
#include <strings.h>
#include <errno.h>
#include <stdio.h>

/* Test shmctl IPC_RMID 
 */

#ifdef DEBUG
#define dprintf printf
#else
#define dprintf if (0) printf
#endif

key_t ftok_check (char *name, int index)
{
  key_t temp;

  dprintf ("ftok (\'%s\',%d)...", name, index);
  temp = ftok (name, index);
  if (temp == (key_t) - 1)
    {
      dprintf ("error %d, %s\n", errno, strerror (errno));
      exit (1);
    }
  dprintf ("key value %0qx\n", temp);
  return temp;
}


int
main (void)
{
  key_t mykey;
  int shmid, shmid1;
  struct shmid_ds shmds;
  mykey = ftok_check ("shmctl_rmid.o",1 );

  dprintf ("creating key... ");
  shmid = shmget (mykey, 65536, 0777 | IPC_CREAT);
  if (shmid != -1)
  {dprintf ("id %0x\n", shmid);}
  else
    {
      dprintf ("failed\nerror %d, %s\n", errno, strerror (errno));
      return 1;
    }
  dprintf ("delete private key... ");
  if (shmctl(shmid, IPC_RMID, NULL))
    {
      dprintf ("failed\nerror %d, %s\n", errno, strerror (errno));
      return 1;
    }
  else if ((shmid1 = shmget (mykey, 65536, 0777)) != -1)
    {
      dprintf ("failed - the id is still in existence\n");
      return 1;
    }
  else
  {dprintf("ok\n");}
  // now the shmget one
  dprintf("Retrieving saved id\n");
  {
    FILE *f;
    if ((f = fopen ("shmid.txt","rt")))
      {
	if (!fscanf (f, "%x", &shmid))
	  {
	    dprintf ("couldn't scan saved id\n");
	    return 1;
	  }
	fclose (f);
	dprintf ("Saved id is %0x\n", shmid);
	dprintf ("delete saved id... ");
	if (shmctl(shmid, IPC_RMID, NULL))
	  {
	    dprintf ("failed\nerror %d, %s\n", errno, strerror (errno));
	    return 1;
	  }
	// FIXME: test for the id being present - ie via a ctl stats call
	else
	{dprintf("ok\n");}


	  
      }
    else
    {
      dprintf ("couldn't open saved id file\n");
    }
    
  }

  return 0;
}
